---
title: Array.prototype.fill()
slug: Web/JavaScript/Reference/Global_Objects/Array/fill
tags:
  - Array
  - ECMAScript 2015
  - JavaScript
  - Method
  - Prototype
  - polyfill
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <code><strong>fill()</strong></code> method changes all elements in an array to a static value, from a start index (default <code>0</code>) to an end index (default <code>array.length</code>). It returns the modified array.</span></p>

<div>{{EmbedInteractiveExample("pages/js/array-fill.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>arr</var>.fill(<var>value[</var>, <var>start[<var>, <var>end]]</var>)</var></var>
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>value</code></dt>
 <dd>Value to fill the array with. (Note all elements in the array will be this exact value.)</dd>
 <dt><code>start</code> {{optional_inline}}</dt>
 <dd>Start index, default <code>0</code>.</dd>
 <dt><code>end</code> {{optional_inline}}</dt>
 <dd>End index, default <code>arr.length</code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The modified array, filled with <code>value</code>.</p>

<h2 id="Description">Description</h2>

<ul>
 <li>If <code>start</code> is negative, it is treated as <code>array.length + start</code>.</li>
 <li>If <code>end</code> is negative, it is treated as <code>array.length + end</code>.</li>
 <li><code>fill</code> is intentionally generic: it does not require that its <code>this</code> value be an <code>Array</code> object.</li>
 <li><code>fill</code> is a mutator method: it will change the array itself and return it, not a copy of it.</li>
 <li>If the first parameter is an object, each slot in the array will reference that object.</li>
</ul>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush: js notranslate">if (!Array.prototype.fill) {
  Object.defineProperty(Array.prototype, 'fill', {
    value: function(value) {

      // Steps 1-2.
      if (this == null) {
        throw new TypeError('this is null or not defined');
      }

      var O = Object(this);

      // Steps 3-5.
      var len = O.length &gt;&gt;&gt; 0;

      // Steps 6-7.
      var start = arguments[1];
      var relativeStart = start &gt;&gt; 0;

      // Step 8.
      var k = relativeStart &lt; 0 ?
        Math.max(len + relativeStart, 0) :
        Math.min(relativeStart, len);

      // Steps 9-10.
      var end = arguments[2];
      var relativeEnd = end === undefined ?
        len : end &gt;&gt; 0;

      // Step 11.
      var finalValue = relativeEnd &lt; 0 ?
        Math.max(len + relativeEnd, 0) :
        Math.min(relativeEnd, len);

      // Step 12.
      while (k &lt; finalValue) {
        O[k] = value;
        k++;
      }

      // Step 13.
      return O;
    }
  });
}
</pre>

<p>If you need to support truly obsolete JavaScript engines that don't support <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/defineProperty">Object.defineProperty</a></code>, it's best not to polyfill <code>Array.prototype</code> methods at all, as you can't make them non-enumerable.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_fill">Using fill</h3>

<pre class="brush: js notranslate">[1, 2, 3].fill(4)                // [4, 4, 4]
[1, 2, 3].fill(4, 1)             // [1, 4, 4]
[1, 2, 3].fill(4, 1, 2)          // [1, 4, 3]
[1, 2, 3].fill(4, 1, 1)          // [1, 2, 3]
[1, 2, 3].fill(4, 3, 3)          // [1, 2, 3]
[1, 2, 3].fill(4, -3, -2)        // [4, 2, 3]
[1, 2, 3].fill(4, NaN, NaN)      // [1, 2, 3]
[1, 2, 3].fill(4, 3, 5)          // [1, 2, 3]
Array(3).fill(4)                 // [4, 4, 4]
[].fill.call({ length: 3 }, 4)   // {0: 4, 1: 4, 2: 4, length: 3}

// A single object, referenced by each slot of the array:
let arr = Array(3).fill({}) // [{}, {}, {}]
arr[0].hi = "hi"            // [{ hi: "hi" }, { hi: "hi" }, { hi: "hi" }]
</pre>

<h3 id="Using_fill_to_create_a_matrix">Using fill to create a matrix</h3>

<pre class="brush: js notranslate">let arr = new Array(3);
arr.fill(new Array(4)); // Each value of the array <em>arr </em>is a reference to newly created array of size 4
arr[0][0] = 10;
console.log(arr[0][0]); // 10
console.log(arr[1][0]); // 10
console.log(arr[2][0]); // 10
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-array.prototype.fill', 'Array.prototype.fill')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Array.fill")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array")}}</li>
 <li>{{jsxref("TypedArray.prototype.fill()")}}</li>
</ul>
